package com.qmth.themis.business.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.themis.business.bean.exam.ExamPrepareBean;
import com.qmth.themis.business.dao.TEExamMapper;
import com.qmth.themis.business.entity.TEExam;
import com.qmth.themis.business.service.TEExamActivityService;
import com.qmth.themis.business.service.TEExamService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Objects;

/**
 * @Description: 考试批次 服务实现类
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2020/6/25
 */
@Service
public class TEExamServiceImpl extends ServiceImpl<TEExamMapper, TEExam> implements TEExamService {

    @Resource
    TEExamMapper teExamMapper;

    @Resource
    TEExamActivityService examActivityService;

    /**
     * 查询考试批次
     *
     * @param iPage
     * @param id
     * @param code
     * @param name
     * @param mode
     * @param enable
     * @return
     */
    @Override
    public IPage<TEExam> examQuery(IPage<Map> iPage, Long id, String code, String name, Integer mode, Integer enable) {
        return teExamMapper.examQuery(iPage, id, code, name, mode, enable);
    }

    /**
     * 获取考试待考列表
     *
     * @param studentId
     * @return
     */
    @Override
    public List<Map> getWaitingExam(Long studentId) {
        List<Map> list = teExamMapper.getWaitingExam(studentId);
        if (Objects.nonNull(list) && list.size() > 0) {
            for (int i = 0; i < list.size(); i++) {
                Map m = list.get(i);
                List<Map> teExamActivityList = examActivityService.getWaitingExam(studentId, Long.parseLong(String.valueOf(m.get("id"))), Long.parseLong(String.valueOf(m.get("examActivityId"))));
                m.put("activities", teExamActivityList);
            }
        }
        return list;
    }

    @Transactional
	@Override
	public ExamPrepareBean prepare(Long studentId, Long activityId) {
		// TODO Auto-generated method stub
		return null;
	}
}
